#include <iostream>
#include <vector>

const int MX = 1e6 + 5;

int n, q;
std::vector<int> adj[MX];

int subtr[MX];
void dfs(int cur) {
    subtr[cur] = 1;
    for(int i = 0; i < adj[cur].size(); i++) {
        dfs(adj[cur][i]); subtr[cur] += subtr[adj[cur][i]];
    }
}

int main () {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);

    std::cin>>n;
    bool is_a_subord[n];
    for(int i = 0; i < n - 1; i++) {
        int a, b; std::cin>>a>>b;
        is_a_subord[b - 1] = true;
        adj[a].push_back(b);
    }
    int root;
    for(int i = 0; i < n; i++) if (is_a_subord[i] == false) {
        root = i + 1; break;
    }
    dfs(root);

    std::cin>>q; int qry[q];
    for(int i = 0; i < q; i++) {
        int a; std::cin>>a;
        qry[i] = subtr[a] - 1;
    }
    for(int i = 0; i < q; i++) {
        std::cout<<qry[i]<<"\n";
    }
    return 0;
}
